// WctpClientSend.cpp

#include "WctpFactory.hpp"
#include "WctpClientOperations.hpp"
#include "WctpClientReceive.hpp"

using namespace std;

int main() {
  WctpClientOperations wctpOps;
  WctpClientReceive wctpRx;

  std::string timestamp = wctpOps.getTimeStamp();
  std::string pin, mssg, email, carrierAddr, postDir;

  int receipt;

  std::cout << endl << "Enter the carrier address: ";
  std::cin >> carrierAddr;
	std::cout << endl << "What directory should I post to on the server? (i.e. /wctp ) : ";
	std::cin >> postDir;
  std::cout << endl << "Enter the device ID: ";
  std::cin >> pin;
  std::cout << endl << "Enter the message: ";
  cin.ignore();
  std::getline(std::cin, mssg);
  std::cout << endl << "Enter an email address: ";
  std::cin >> email;
  std::cout << endl << "Enter '1' if you would like a receipt, or '0' if not: " << endl;
  std::cin >> receipt;

	bool notify;

	if (receipt == 1) {
		notify = true;
	}
	else {
		notify = false;
	}

  string wctpPacket = wctpOps.submitMessage(postDir, timestamp, pin, mssg, email, notify);
  std::cout << endl << wctpPacket << endl;

  /*
  string pollerID = "Arch.dal";
  string securityCode = "pollpass";
  string maxMssgInBatch = "2";

  string wctpPacket = wctpOps.clientQuery(pollerID, securityCode, maxMssgInBatch);
  */

  std::string response = wctpOps.wctpSend(wctpPacket, carrierAddr);
  int wctpCode = wctpRx.getResponseCode(response);
  std::cout << endl << response << endl;
  std::cout << endl << "Response Code: " << wctpOps.intToString(wctpCode);
  std::cout << endl << "Response Text: " << wctpRx.findCode(wctpCode);
  std::cout << endl << "Tracking Code: " << wctpRx.getTrackingCode(response);

  /*
  string deviceID = "7439373";
  string senderID = "klatham@arch.com";
  string trackNo = "0008530440";

  string wctpPacket3 = wctpOps.clientQuery(deviceID, senderID, trackNo);

  cout << endl << endl << wctpPacket << endl;

  char *carrierAddr1 = "10.48.5.201";
  char *wctpPacket4 = wctpPacket3.c_str();

  wctpOps.wctpSend(wctpPacket4, carrierAddr1);
  */
}
